OGRE: Ogre::SceneNode Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::SceneNode Class Reference

Class representing a node in the scene graph. More...

`#include <OgreSceneNode.h>`

Inheritance diagram for Ogre::SceneNode:

[legend]
List of all members.

## Public Types

typedef HashMap< String, MovableObject * > | ObjectMap
typedef MapIterator< ObjectMap > | ObjectIterator
typedef ConstMapIterator< ObjectMap > | ConstObjectIterator
typedef HashMap< String, Node * > | ChildNodeMap
typedef MapIterator< ChildNodeMap > | ChildNodeIterator
typedef ConstMapIterator< ChildNodeMap > | ConstChildNodeIterator
enum | TransformSpace { TS_LOCAL, TS_PARENT, TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...

## Public Member Functions

| SceneNode (SceneManager *creator)
| Constructor, only to be called by the creator SceneManager.
| SceneNode (SceneManager *creator, const String &name)
| Constructor, only to be called by the creator SceneManager.
| ~SceneNode ()
virtual void | attachObject (MovableObject *obj)
| Adds an instance of a scene object to this node.
virtual unsigned short | numAttachedObjects (void) const
| Reports the number of objects attached to this node.
virtual MovableObject * | getAttachedObject (unsigned short index)
| Retrieves a pointer to an attached object.
virtual MovableObject * | getAttachedObject (const String &name)
| Retrieves a pointer to an attached object.
virtual MovableObject * | detachObject (unsigned short index)
| Detaches the indexed object from this scene node.
virtual void | detachObject (MovableObject *obj)
| Detaches an object by pointer.
virtual MovableObject * | detachObject (const String &name)
| Detaches the named object from this node and returns a pointer to it.
virtual void | detachAllObjects (void)
| Detaches all objects attached to this node.
virtual bool | isInSceneGraph (void) const
| Determines whether this node is in the scene graph, ie whether it's ulitimate ancestor is the root scene node.
virtual void | _notifyRootNode (void)
| Notifies this SceneNode that it is the root scene node.
virtual void | _update (bool updateChildren, bool parentHasChanged)
| Internal method to update the Node.
virtual void | _updateBounds (void)
| Tells the SceneNode to update the world bound info it stores.
virtual void | _findVisibleObjects (Camera *cam, RenderQueue *queue, VisibleObjectsBoundsInfo *visibleBounds, bool includeChildren=true, bool displayNodes=false, bool onlyShadowCasters=false)
| Internal method which locates any visible objects attached to this node and adds them to the passed in queue.
virtual const AxisAlignedBox & | _getWorldAABB (void) const
| Gets the axis-aligned bounding box of this node (and hence all subnodes).
virtual ObjectIterator | getAttachedObjectIterator (void)
| Retrieves an iterator which can be used to efficiently step through the objects attached to this node.
virtual ConstObjectIterator | getAttachedObjectIterator (void) const
| Retrieves an iterator which can be used to efficiently step through the objects attached to this node.
SceneManager * | getCreator (void) const
| Gets the creator of this scene node.
virtual void | removeAndDestroyChild (const String &name)
| This method removes and destroys the named child and all of its children.
virtual void | removeAndDestroyChild (unsigned short index)
| This method removes and destroys the child and all of its children.
virtual void | removeAndDestroyAllChildren (void)
| Removes and destroys all children of this node.
virtual void | showBoundingBox (bool bShow)
| Allows the showing of the node's bounding box.
virtual void | _addBoundingBoxToQueue (RenderQueue *queue)
| Add the bounding box to the rendering queue.
virtual bool | getShowBoundingBox () const
| This allows scene managers to determine if the node's bounding box should be added to the rendering queue.
virtual SceneNode * | createChildSceneNode (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new SceneNode as a child of this node.
virtual SceneNode * | createChildSceneNode (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named SceneNode as a child of this node.
virtual void | findLights (LightList &destList, Real radius) const
| Allows retrieval of the nearest lights to the centre of this SceneNode.
virtual void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the node whether to yaw around it's own local Y axis or a fixed axis of choice.
virtual void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Y-axis.
virtual void | setDirection (Real x, Real y, Real z, TransformSpace relativeTo=TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Sets the node's direction vector ie it's local -z.
virtual void | setDirection (const Vector3 &vec, TransformSpace relativeTo=TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Sets the node's direction vector ie it's local -z.
virtual void | lookAt (const Vector3 &targetPoint, TransformSpace relativeTo, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Points the local -Z direction of this node at a point in space.
virtual void | setAutoTracking (bool enabled, SceneNode *target=0, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of another SceneNode.
virtual SceneNode * | getAutoTrackTarget (void)
| Get the auto tracking target for this node, if any.
virtual const Vector3 & | getAutoTrackOffset (void)
| Get the auto tracking offset for this node, if the node is auto tracking.
virtual const Vector3 & | getAutoTrackLocalDirection (void)
| Get the auto tracking local direction for this node, if it is auto tracking.
void | _autoTrack (void)
| Internal method used by OGRE to update auto-tracking cameras.
SceneNode * | getParentSceneNode (void) const
| Gets the parent of this SceneNode.
virtual void | setVisible (bool visible, bool cascade=true)
| Makes all objects attached to this node become visible / invisble.
virtual void | flipVisibility (bool cascade=true)
| Inverts the visibility of all objects attached to this node.
const String & | getName (void) const
| Returns the name of the node.
virtual Node * | getParent (void) const
| Gets this node's parent (NULL if this is the root).
virtual const Quaternion & | getOrientation () const
| Returns a quaternion representing the nodes orientation.
virtual void | setOrientation (const Quaternion &q)
| Sets the orientation of this node via a quaternion.
virtual void | setOrientation (Real w, Real x, Real y, Real z)
| Sets the orientation of this node via quaternion parameters.
virtual void | resetOrientation (void)
| Resets the nodes orientation (local axes as world axes, no rotation).
virtual void | setPosition (const Vector3 &pos)
| Sets the position of the node relative to it's parent.
virtual void | setPosition (Real x, Real y, Real z)
| Sets the position of the node relative to it's parent.
virtual const Vector3 & | getPosition (void) const
| Gets the position of the node relative to it's parent.
virtual void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this node.
virtual void | setScale (Real x, Real y, Real z)
| Sets the scaling factor applied to this node.
virtual const Vector3 & | getScale (void) const
| Gets the scaling factor of this node.
virtual void | setInheritOrientation (bool inherit)
| Tells the node whether it should inherit orientation from it's parent node.
virtual bool | getInheritOrientation (void) const
| Returns true if this node is affected by orientation applied to the parent node.
virtual void | setInheritScale (bool inherit)
| Tells the node whether it should inherit scaling factors from it's parent node.
virtual bool | getInheritScale (void) const
| Returns true if this node is affected by scaling factors applied to the parent node.
virtual void | scale (const Vector3 &scale)
| Scales the node, combining it's current scale with the passed in scaling factor.
virtual void | scale (Real x, Real y, Real z)
| Scales the node, combining it's current scale with the passed in scaling factor.
virtual void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the cartesian axes.
virtual void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the cartesian axes.
virtual void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Z-axis.
virtual void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the X-axis.
virtual void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis.
virtual void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an aritrary axis using a Quarternion.
virtual Matrix3 | getLocalAxes (void) const
| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.
virtual Node * | createChild (const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new Node as a child of this node.
virtual Node * | createChild (const String &name, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates a new named Node as a child of this node.
virtual void | addChild (Node *child)
| Adds a (precreated) child scene node to this node.
virtual unsigned short | numChildren (void) const
| Reports the number of child nodes under this one.
virtual Node * | getChild (unsigned short index) const
| Gets a pointer to a child node.
virtual Node * | getChild (const String &name) const
| Gets a pointer to a named child node.
virtual ChildNodeIterator | getChildIterator (void)
| Retrieves an iterator for efficiently looping through all children of this node.
virtual ConstChildNodeIterator | getChildIterator (void) const
| Retrieves an iterator for efficiently looping through all children of this node.
virtual Node * | removeChild (unsigned short index)
| Drops the specified child from this node.
virtual Node * | removeChild (Node *child)
| Drops the specified child from this node.
virtual Node * | removeChild (const String &name)
| Drops the named child from this node.
virtual void | removeAllChildren (void)
| Removes all child Nodes attached to this node.
virtual const Quaternion & | _getDerivedOrientation (void) const
| Gets the orientation of the node as derived from all parents.
virtual const Vector3 & | _getDerivedPosition (void) const
| Gets the position of the node as derived from all parents.
virtual const Vector3 & | _getDerivedScale (void) const
| Gets the scaling factor of the node as derived from all parents.
virtual const Matrix4 & | _getFullTransform (void) const
| Gets the full transformation matrix for this node.
virtual void | setListener (Listener *listener)
| Sets a listener for this Node.
virtual Listener * | getListener (void) const
| Gets the current listener for this Node.
const MaterialPtr & | getMaterial (void) const
| Overridden from Renderable.
void | getRenderOperation (RenderOperation &op)
| Overridden from Renderable.
void | getWorldTransforms (Matrix4 *xform) const
| Overridden from Renderable.
const Quaternion & | getWorldOrientation (void) const
const Vector3 & | getWorldPosition (void) const
virtual void | setInitialState (void)
| Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.
virtual void | resetToInitialState (void)
| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.
virtual const Vector3 & | getInitialPosition (void) const
| Gets the initial position of this node, see setInitialState for more info.
virtual const Quaternion & | getInitialOrientation (void) const
| Gets the initial orientation of this node, see setInitialState for more info.
virtual const Vector3 & | getInitialScale (void) const
| Gets the initial position of this node, see setInitialState for more info.
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable.
virtual void | needUpdate (bool forceParentUpdate=false)
| To be called in the event of transform changes to this node that require it's recalculation.
virtual void | requestUpdate (Node *child, bool forceParentUpdate=false)
| Called by children to notify their parent that they need an update.
virtual void | cancelUpdate (Node *child)
| Called by children to notify their parent that they no longer need an update.
const LightList & | getLights (void) const

Remarks:
  Directional lights, which have no position, will always be first on this list.

virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

## Static Public Member Functions

static void | queueNeedUpdate (Node *n)
| Queue a 'needUpdate' call to a node safely.
static void | processQueuedUpdates (void)
| Process queued 'needUpdate' calls.

## Protected Types

typedef std::set< Node * > | ChildUpdateSet
typedef std::vector< Node * > | QueuedUpdates
typedef std::map< size_t, Vector4 > | CustomParameterMap

## Protected Member Functions

void | updateFromParentImpl (void) const

Remarks:
  Splitting the implementation of the update away from the update call itself allows the detail to be overridden without disrupting the general sequence of updateFromParent (e.g. raising events)

.

Node * | createChildImpl (void)
| See Node.
Node * | createChildImpl (const String &name)
| See Node.
void | setParent (Node *parent)
| See Node.
virtual void | setInSceneGraph (bool inGraph)
| Internal method for setting whether the node is in the scene graph.
virtual void | _updateFromParent (void) const
| Triggers the node to update it's combined transforms.

## Protected Attributes

ObjectMap | mObjectsByName
WireBoundingBox * | mWireBoundingBox
| Pointer to a Wire Bounding Box for this Node.
bool | mShowBoundingBox
| Flag that determines if the bounding box of the node should be displayed.
SceneManager * | mCreator
| SceneManager which created this node.
AxisAlignedBox | mWorldAABB
| World-Axis aligned bounding box, updated only through _update.
bool | mYawFixed
| Whether to yaw around a fixed axis.
Vector3 | mYawFixedAxis
| Fixed axis to yaw around.
SceneNode * | mAutoTrackTarget
| Auto tracking target.
Vector3 | mAutoTrackOffset
| Tracking offset for fine tuning.
Vector3 | mAutoTrackLocalDirection
| Local 'normal' direction vector.
bool | mIsInSceneGraph
| Is this node a current part of the scene graph?
Node * | mParent
| Pointer to parent node.
ChildNodeMap | mChildren
| Collection of pointers to direct children; hashmap for efficiency.
ChildUpdateSet | mChildrenToUpdate
| List of children which need updating, used if self is not out of date but children are.
bool | mNeedParentUpdate
| Flag to indicate own transform from parent is out of date.
bool | mNeedChildUpdate
| Flag indicating that all children need to be updated.
bool | mParentNotified
| Flag indicating that parent has been notified about update request.
bool | mQueuedForUpdate
| Flag indicating that the node has been queued for update.
String | mName
| Friendly name of this node, can be automatically generated if you don't care.
Quaternion | mOrientation
| Stores the orientation of the node relative to it's parent.
Vector3 | mPosition
| Stores the position/translation of the node relative to its parent.
Vector3 | mScale
| Stores the scaling factor applied to this node.
bool | mInheritOrientation
| Stores whether this node inherits orientation from it's parent.
bool | mInheritScale
| Stores whether this node inherits scale from it's parent.
MaterialPtr | mpMaterial
| Material pointer should this node be rendered.
Quaternion | mDerivedOrientation
| Cached combined orientation.
Vector3 | mDerivedPosition
| Cached combined position.
Vector3 | mDerivedScale
| Cached combined scale.
Vector3 | mInitialPosition
| The position to use as a base for keyframe animation.
Quaternion | mInitialOrientation
| The orientation to use as a base for keyframe animation.
Vector3 | mInitialScale
| The scale to use as a base for keyframe animation.
Matrix4 | mCachedTransform
| Cached derived transform as a 4x4 matrix.
bool | mCachedTransformOutOfDate
Listener * | mListener
| Node listener - only one allowed (no list) for size & performance reasons.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView

## Static Protected Attributes

static unsigned long | msNextGeneratedNameExt
| Incremented count for next name extension.
static QueuedUpdates | msQueuedUpdates
static const PlaneList | msDummyPlaneList

## Detailed Description

Class representing a node in the scene graph.

Remarks:
  A SceneNode is a type of Node which is used to organise objects in a scene. It has the same hierarchical transformation properties of the generic Node class, but also adds the ability to attach world objects to the node, and stores hierarchical bounding volumes of the nodes in the tree. Child nodes are contained within the bounds of the parent, and so on down the tree, allowing for fast culling.

Definition at line 52 of file OgreSceneNode.h.

## Member Typedef Documentation

typedef MapIterator<ChildNodeMap> Ogre::Node::ChildNodeIterator`[inherited]`

| Definition at line 69 of file OgreNode.h.

typedef HashMap<String, Node*> Ogre::Node::ChildNodeMap`[inherited]`

| Definition at line 68 of file OgreNode.h.

typedef std::set<Node*> Ogre::Node::ChildUpdateSet`[protected, inherited]`

| Definition at line 101 of file OgreNode.h.

typedef ConstMapIterator<ChildNodeMap> Ogre::Node::ConstChildNodeIterator`[inherited]`

| Definition at line 70 of file OgreNode.h.

typedef ConstMapIterator<ObjectMap> Ogre::SceneNode::ConstObjectIterator

| Definition at line 57 of file OgreSceneNode.h.

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

typedef MapIterator<ObjectMap> Ogre::SceneNode::ObjectIterator

| Definition at line 56 of file OgreSceneNode.h.

typedef HashMap<String, MovableObject*> Ogre::SceneNode::ObjectMap

| Definition at line 55 of file OgreSceneNode.h.

typedef std::vector<Node*> Ogre::Node::QueuedUpdates`[protected, inherited]`

| Definition at line 204 of file OgreNode.h.

## Member Enumeration Documentation

enum Ogre::Node::TransformSpace`[inherited]`

Enumeration denoting the spaces which a transform can be relative to.

Enumeration values:

  TS_LOCAL | Transform is relative to the local space.
  TS_PARENT | Transform is relative to the space of the parent node.
  TS_WORLD | Transform is relative to world space.

Definition at line 59 of file OgreNode.h.

## Constructor & Destructor Documentation

Ogre::SceneNode::SceneNode | ( | SceneManager * | creator | ) |

Constructor, only to be called by the creator SceneManager.

Remarks:
  Creates a node with a generated name.

Ogre::SceneNode::SceneNode | ( | SceneManager * | creator,
|  | const String & | name
| ) |

Constructor, only to be called by the creator SceneManager.

Remarks:
  Creates a node with a specified name.

Ogre::SceneNode::~SceneNode | ( |  | ) |

## Member Function Documentation

virtual void Ogre::SceneNode::_addBoundingBoxToQueue | ( | RenderQueue * | queue | ) | `[virtual]`

| Add the bounding box to the rendering queue.

void Ogre::SceneNode::_autoTrack | ( | void |  | ) |

| Internal method used by OGRE to update auto-tracking cameras.

virtual void Ogre::SceneNode::_findVisibleObjects | ( | Camera * | cam,
|  | RenderQueue * | queue,
|  | VisibleObjectsBoundsInfo * | visibleBounds,
|  | bool | includeChildren = `true`,
|  | bool | displayNodes = `false`,
|  | bool | onlyShadowCasters = `false`
| ) | `[virtual]`

Internal method which locates any visible objects attached to this node and adds them to the passed in queue.

Remarks:
  Should only be called by a SceneManager implementation, and only after the _updat method has been called to ensure transforms and world bounds are up to date. SceneManager implementations can choose to let the search cascade automatically, or choose to prevent this and select nodes themselves based on some other criteria.

Parameters:

  | cam | The active camera
  | queue | The SceneManager's rendering queue
  | visibleBounds | bounding information created on the fly containing all visible objects by the camera
  | includeChildren | If true, the call is cascaded down to all child nodes automatically.
  | displayNodes | If true, the nodes themselves are rendered as a set of 3 axes as well as the objects being rendered. For debugging purposes.

virtual const Quaternion& Ogre::Node::_getDerivedOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Gets the orientation of the node as derived from all parents.

virtual const Vector3& Ogre::Node::_getDerivedPosition | ( | void |  | ) | const`[virtual, inherited]`

| Gets the position of the node as derived from all parents.

virtual const Vector3& Ogre::Node::_getDerivedScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the scaling factor of the node as derived from all parents.

virtual const Matrix4& Ogre::Node::_getFullTransform | ( | void |  | ) | const`[virtual, inherited]`

Gets the full transformation matrix for this node.

Remarks:
  This method returns the full transformation matrix for this node, including the effect of any parent node transformations, provided they have been updated using the Node::_update method. This should only be called by a SceneManager which knows the derived transforms have been updated before calling this method. Applications using Ogre should just use the relative transforms.

virtual const AxisAlignedBox& Ogre::SceneNode::_getWorldAABB | ( | void |  | ) | const`[virtual]`

Gets the axis-aligned bounding box of this node (and hence all subnodes).

Remarks:
  Recommended only if you are extending a SceneManager, because the bounding box returned from this method is only up to date after the SceneManager has called _update.

virtual void Ogre::SceneNode::_notifyRootNode | ( | void |  | ) | `[virtual]`

Notifies this SceneNode that it is the root scene node.

Remarks:
  Only SceneManager should call this!

Definition at line 163 of file OgreSceneNode.h.

virtual void Ogre::SceneNode::_update | ( | bool | updateChildren,
|  | bool | parentHasChanged
| ) | `[virtual]`

Internal method to update the Node.

Note:
  Updates this scene node and any relevant children to incorporate transforms etc. Don't call this yourself unless you are writing a SceneManager implementation.

Parameters:

  | updateChildren | If true, the update cascades down to all children. Specify false if you wish to update children separately, e.g. because of a more selective SceneManager implementation.
  | parentHasChanged | This flag indicates that the parent xform has changed, so the child should retrieve the parent's xform and combine it with its own even if it hasn't changed itself.

Reimplemented from Ogre::Node.

virtual void Ogre::SceneNode::_updateBounds | ( | void |  | ) | `[virtual]`

| Tells the SceneNode to update the world bound info it stores.

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks:
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters:

  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::SubEntity.

Definition at line 252 of file OgreRenderable.h.

virtual void Ogre::Node::_updateFromParent | ( | void |  | ) | const`[protected, virtual, inherited]`

Triggers the node to update it's combined transforms.

  This method is called internally by Ogre to ask the node to update it's complete transformation based on it's parents derived transform.

virtual void Ogre::Node::addChild | ( | Node * | child | ) | `[virtual, inherited]`

Adds a (precreated) child scene node to this node.

If it is attached to another node, it must be detached first.

Parameters:

  | child | The Node which is to become a child node of this one

virtual void Ogre::SceneNode::attachObject | ( | MovableObject * | obj | ) | `[virtual]`

Adds an instance of a scene object to this node.

Remarks:
  Scene objects can include Entity objects, Camera objects, Light objects, ParticleSystem objects etc. Anything that subclasses from MovableObject.

virtual void Ogre::Node::cancelUpdate | ( | Node * | child | ) | `[virtual, inherited]`

| Called by children to notify their parent that they no longer need an update.

virtual Node* Ogre::Node::createChild | ( | const String & | name,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual, inherited]`

Creates a new named Node as a child of this node.

Remarks:
  This creates a child node with a given name, which allows you to look the node up from the parent which holds this collection of nodes.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

virtual Node* Ogre::Node::createChild | ( | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual, inherited]`

Creates an unnamed new Node as a child of this node.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

Node* Ogre::SceneNode::createChildImpl | ( | const String & | name | ) | `[protected, virtual]`

| See Node. Implements Ogre::Node.

Node* Ogre::SceneNode::createChildImpl | ( | void |  | ) | `[protected, virtual]`

| See Node. Implements Ogre::Node.

virtual SceneNode* Ogre::SceneNode::createChildSceneNode | ( | const String & | name,
|  | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual]`

Creates a new named SceneNode as a child of this node.

Remarks:
  This creates a child node with a given name, which allows you to look the node up from the parent which holds this collection of nodes.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

virtual SceneNode* Ogre::SceneNode::createChildSceneNode | ( | const Vector3 & | translate = `Vector3::ZERO`,
|  | const Quaternion & | rotate = `Quaternion::IDENTITY`
| ) | `[virtual]`

Creates an unnamed new SceneNode as a child of this node.

Parameters:

  | translate | Initial translation offset of child relative to parent
  | rotate | Initial rotation relative to parent

virtual void Ogre::SceneNode::detachAllObjects | ( | void |  | ) | `[virtual]`

| Detaches all objects attached to this node.

virtual MovableObject* Ogre::SceneNode::detachObject | ( | const String & | name | ) | `[virtual]`

| Detaches the named object from this node and returns a pointer to it.

virtual void Ogre::SceneNode::detachObject | ( | MovableObject * | obj | ) | `[virtual]`

| Detaches an object by pointer.

virtual MovableObject* Ogre::SceneNode::detachObject | ( | unsigned short | index | ) | `[virtual]`

Detaches the indexed object from this scene node.

Remarks:
  Detaches by index, see the alternate version to detach by name. Object indexes may change as other objects are added / removed.

virtual void Ogre::SceneNode::findLights | ( | LightList & | destList,
|  | Real | radius
| ) | const`[virtual]`

Allows retrieval of the nearest lights to the centre of this SceneNode.

Remarks:
  This method allows a list of lights, ordered by proximity to the centre of this SceneNode, to be retrieved. Can be useful when implementing MovableObject::queryLights and Renderable::getLights.

  Note that only lights could be affecting the frustum will take into account, which cached in scene manager.

See also:
  SceneManager::_getLightsAffectingFrustum

  SceneManager::_populateLightList

Parameters:

  | destList | List to be populated with ordered set of lights; will be cleared by this method before population.
  | radius | Parameter to specify lights intersecting a given radius of this SceneNode's centre.

virtual void Ogre::SceneNode::flipVisibility | ( | bool | cascade = `true` | ) | `[virtual]`

Inverts the visibility of all objects attached to this node.

Remarks:
  This is a shortcut to calling setVisible(!isVisible()) on the objects attached to this node, and optionally to all objects attached to child nodes.

Parameters:

  | cascade | If true, this setting cascades into child nodes too.

virtual MovableObject* Ogre::SceneNode::getAttachedObject | ( | const String & | name | ) | `[virtual]`

Retrieves a pointer to an attached object.

Remarks:
  Retrieves by object name, see alternate version to retrieve by index.

virtual MovableObject* Ogre::SceneNode::getAttachedObject | ( | unsigned short | index | ) | `[virtual]`

Retrieves a pointer to an attached object.

Remarks:
  Retrieves by index, see alternate version to retrieve by name. The index of an object may change as other objects are added / removed.

virtual ConstObjectIterator Ogre::SceneNode::getAttachedObjectIterator | ( | void |  | ) | const`[virtual]`

Retrieves an iterator which can be used to efficiently step through the objects attached to this node.

Remarks:
  This is a much faster way to go through all the objects attached to the node than using getAttachedObject. But the iterator returned is only valid until a change is made to the collection (ie an addition or removal) so treat the returned iterator as transient, and don't add / remove items as you go through the iterator, save changes until the end, or retrieve a new iterator after making the change. Making changes to the object returned through the iterator is OK though.

virtual ObjectIterator Ogre::SceneNode::getAttachedObjectIterator | ( | void |  | ) | `[virtual]`

Retrieves an iterator which can be used to efficiently step through the objects attached to this node.

Remarks:
  This is a much faster way to go through all the objects attached to the node than using getAttachedObject. But the iterator returned is only valid until a change is made to the collection (ie an addition or removal) so treat the returned iterator as transient, and don't add / remove items as you go through the iterator, save changes until the end, or retrieve a new iterator after making the change. Making changes to the object returned through the iterator is OK though.

virtual const Vector3& Ogre::SceneNode::getAutoTrackLocalDirection | ( | void |  | ) | `[virtual]`

| Get the auto tracking local direction for this node, if it is auto tracking. Definition at line 416 of file OgreSceneNode.h.

virtual const Vector3& Ogre::SceneNode::getAutoTrackOffset | ( | void |  | ) | `[virtual]`

| Get the auto tracking offset for this node, if the node is auto tracking. Definition at line 414 of file OgreSceneNode.h.

virtual SceneNode* Ogre::SceneNode::getAutoTrackTarget | ( | void |  | ) | `[virtual]`

| Get the auto tracking target for this node, if any. Definition at line 412 of file OgreSceneNode.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

Method which reports whether this renderable would normally cast a shadow.

Remarks:
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 187 of file OgreRenderable.h.

virtual Node* Ogre::Node::getChild | ( | const String & | name | ) | const`[virtual, inherited]`

| Gets a pointer to a named child node.

virtual Node* Ogre::Node::getChild | ( | unsigned short | index | ) | const`[virtual, inherited]`

Gets a pointer to a child node.

Remarks:
  There is an alternate getChild method which returns a named child.

virtual ConstChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) | const`[virtual, inherited]`

Retrieves an iterator for efficiently looping through all children of this node.

Remarks:
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this node. Note that the returned iterator is only valid whilst no children are added or removed from this node. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

virtual ChildNodeIterator Ogre::Node::getChildIterator | ( | void |  | ) | `[virtual, inherited]`

Retrieves an iterator for efficiently looping through all children of this node.

Remarks:
  Using this is faster than repeatedly calling getChild if you want to go through all (or most of) the children of this node. Note that the returned iterator is only valid whilst no children are added or removed from this node. Thus you should not store this returned iterator for later use, nor should you add / remove children whilst iterating through it; store up changes for later. Note that calling methods on returned items in the iterator IS allowed and does not invalidate the iterator.

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

SceneManager* Ogre::SceneNode::getCreator | ( | void |  | ) | const

Gets the creator of this scene node.

Remarks:
  This method returns the SceneManager which created this node. This can be useful for destroying this node.

Definition at line 241 of file OgreSceneNode.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

Gets the custom value associated with this Renderable at the given index.

Parameters:

  | @see | setCustomParaemter for full details.

Definition at line 213 of file OgreRenderable.h.

References OGRE_EXCEPT.

virtual bool Ogre::Node::getInheritOrientation | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this node is affected by orientation applied to the parent node.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  See setInheritOrientation for more info.

virtual bool Ogre::Node::getInheritScale | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this node is affected by scaling factors applied to the parent node.

Remarks:
  See setInheritScale for more info.

virtual const Quaternion& Ogre::Node::getInitialOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Gets the initial orientation of this node, see setInitialState for more info.

virtual const Vector3& Ogre::Node::getInitialPosition | ( | void |  | ) | const`[virtual, inherited]`

Gets the initial position of this node, see setInitialState for more info.

Remarks:
  Also resets the cumulative animation weight used for blending.

virtual const Vector3& Ogre::Node::getInitialScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the initial position of this node, see setInitialState for more info.

const LightList& Ogre::Node::getLights | ( | void |  | ) | const`[virtual, inherited]`

Remarks:
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

Reimplemented in Ogre::TagPoint.

virtual Listener* Ogre::Node::getListener | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current listener for this Node. Definition at line 642 of file OgreNode.h.

virtual Matrix3 Ogre::Node::getLocalAxes | ( | void |  | ) | const`[virtual, inherited]`

| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.

const MaterialPtr& Ogre::Node::getMaterial | ( | void |  | ) | const`[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplayBones()

Implements Ogre::Renderable.

const String& Ogre::Node::getName | ( | void |  | ) | const`[inherited]`

| Returns the name of the node.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

Returns the number of world transform matrices this renderable requires.

Remarks:
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 111 of file OgreRenderable.h.

virtual const Quaternion& Ogre::Node::getOrientation | ( |  | ) | const`[virtual, inherited]`

| Returns a quaternion representing the nodes orientation.

virtual Node* Ogre::Node::getParent | ( | void |  | ) | const`[virtual, inherited]`

| Gets this node's parent (NULL if this is the root).

SceneNode* Ogre::SceneNode::getParentSceneNode | ( | void |  | ) | const

| Gets the parent of this SceneNode.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

virtual const Vector3& Ogre::Node::getPosition | ( | void |  | ) | const`[virtual, inherited]`

| Gets the position of the node relative to it's parent.

void Ogre::Node::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplaySkeleton()

Implements Ogre::Renderable.

virtual const Vector3& Ogre::Node::getScale | ( | void |  | ) | const`[virtual, inherited]`

| Gets the scaling factor of this node.

virtual bool Ogre::SceneNode::getShowBoundingBox | ( |  | ) | const`[virtual]`

This allows scene managers to determine if the node's bounding box should be added to the rendering queue.

Remarks:
  Scene Managers that implement their own _findVisibleObjects will have to check this flag and then use _addBoundingBoxToQueue to add the bounding box wireframe.

Real Ogre::Node::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual, inherited]`

| Overridden, see Renderable. Implements Ogre::Renderable.

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

Retrieves a pointer to the Material Technique this renderable object uses.

Remarks:
  This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using.

Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity.

Definition at line 73 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityProjection

Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

Returns whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also:
  Renderable::setUseIdentityView

Definition at line 161 of file OgreRenderable.h.

const Quaternion& Ogre::Node::getWorldOrientation | ( | void |  | ) | const`[virtual, inherited]`

| Implements Ogre::Renderable.

const Vector3& Ogre::Node::getWorldPosition | ( | void |  | ) | const`[virtual, inherited]`

| Implements Ogre::Renderable.

void Ogre::Node::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual, inherited]`

Overridden from Renderable.

Remarks:
  This is only used if the SceneManager chooses to render the node. This option can be set for SceneNodes at SceneManager::setDisplaySceneNodes, and for entities based on skeletal models using Entity::setDisplaySkeleton()

Implements Ogre::Renderable.

virtual bool Ogre::SceneNode::isInSceneGraph | ( | void |  | ) | const`[virtual]`

| Determines whether this node is in the scene graph, ie whether it's ulitimate ancestor is the root scene node. Definition at line 157 of file OgreSceneNode.h.

virtual void Ogre::SceneNode::lookAt | ( | const Vector3 & | targetPoint,
|  | TransformSpace | relativeTo,
|  | const Vector3 & | localDirectionVector = `Vector3::NEGATIVE_UNIT_Z`
| ) | `[virtual]`

Points the local -Z direction of this node at a point in space.

Parameters:

  | targetPoint | A vector specifying the look at point.
  | relativeTo | The space in which the point resides
  | localDirectionVector | The vector which normally describes the natural direction of the node, usually -Z

virtual void Ogre::Node::needUpdate | ( | bool | forceParentUpdate = `false` | ) | `[virtual, inherited]`

To be called in the event of transform changes to this node that require it's recalculation.

Remarks:
  This not only tags the node state as being 'dirty', it also requests it's parent to know about it's dirtiness so it will get an update next time.

Parameters:

  | forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

Reimplemented in Ogre::Bone, and Ogre::TagPoint.

virtual unsigned short Ogre::SceneNode::numAttachedObjects | ( | void |  | ) | const`[virtual]`

| Reports the number of objects attached to this node.

virtual unsigned short Ogre::Node::numChildren | ( | void |  | ) | const`[virtual, inherited]`

| Reports the number of child nodes under this one.

virtual void Ogre::Node::pitch | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around the X-axis.

static void Ogre::Node::processQueuedUpdates | ( | void |  | ) | `[static, inherited]`

| Process queued 'needUpdate' calls.

static void Ogre::Node::queueNeedUpdate | ( | Node * | n | ) | `[static, inherited]`

| Queue a 'needUpdate' call to a node safely. You can't call needUpdate() during the scene graph update, e.g. in response to a Node::Listener hook, because the graph is already being updated, and update flag changes cannot be made reliably in that context. Call this method if you need to queue a needUpdate call in this case.

virtual void Ogre::Node::removeAllChildren | ( | void |  | ) | `[virtual, inherited]`

| Removes all child Nodes attached to this node. Does not delete the nodes, just detaches them from this parent, potentially to be reattached elsewhere.

virtual void Ogre::SceneNode::removeAndDestroyAllChildren | ( | void |  | ) | `[virtual]`

Removes and destroys all children of this node.

Remarks:
  Use this to destroy all child nodes of this node and remove them from the scene graph. Note that all objects attached to this node will be detached but will not be destroyed.

virtual void Ogre::SceneNode::removeAndDestroyChild | ( | unsigned short | index | ) | `[virtual]`

This method removes and destroys the child and all of its children.

Remarks:
  Unlike removeChild, which removes a single named child from this node but does not destroy it, this method destroys the child and all of it's children.

  Use this if you wish to recursively destroy a node as well as detaching it from it's parent. Note that any objects attached to the nodes will be detached but will not themselves be destroyed.

virtual void Ogre::SceneNode::removeAndDestroyChild | ( | const String & | name | ) | `[virtual]`

This method removes and destroys the named child and all of its children.

Remarks:
  Unlike removeChild, which removes a single named child from this node but does not destroy it, this method destroys the child and all of it's children.

  Use this if you wish to recursively destroy a node as well as detaching it from it's parent. Note that any objects attached to the nodes will be detached but will not themselves be destroyed.

virtual Node* Ogre::Node::removeChild | ( | const String & | name | ) | `[virtual, inherited]`

Drops the named child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere.

virtual Node* Ogre::Node::removeChild | ( | Node * | child | ) | `[virtual, inherited]`

Drops the specified child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this node.

virtual Node* Ogre::Node::removeChild | ( | unsigned short | index | ) | `[virtual, inherited]`

Drops the specified child from this node.

Remarks:
  Does not delete the node, just detaches it from this parent, potentially to be reattached elsewhere. There is also an alternate version which drops a named child from this node.

virtual void Ogre::Node::requestUpdate | ( | Node * | child,
|  | bool | forceParentUpdate = `false`
| ) | `[virtual, inherited]`

Called by children to notify their parent that they need an update.

Parameters:

  | forceParentUpdate | Even if the node thinks it has already told it's parent, tell it anyway

virtual void Ogre::Node::resetOrientation | ( | void |  | ) | `[virtual, inherited]`

Resets the nodes orientation (local axes as world axes, no rotation).

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

virtual void Ogre::Node::resetToInitialState | ( | void |  | ) | `[virtual, inherited]`

| Resets the position / orientation / scale of this node to it's initial state, see setInitialState for more info.

virtual void Ogre::Node::roll | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around the Z-axis.

virtual void Ogre::Node::rotate | ( | const Quaternion & | q,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around an aritrary axis using a Quarternion.

virtual void Ogre::Node::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual, inherited]`

| Rotate the node around an arbitrary axis.

virtual void Ogre::Node::scale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Scales the node, combining it's current scale with the passed in scaling factor.

Remarks:
  This method applies an extra scaling factor to the node's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the node's origin.

virtual void Ogre::Node::scale | ( | const Vector3 & | scale | ) | `[virtual, inherited]`

Scales the node, combining it's current scale with the passed in scaling factor.

Remarks:
  This method applies an extra scaling factor to the node's existing scale, (unlike setScale which overwrites it) combining it's current scale with the new one. E.g. calling this method twice with Vector3(2,2,2) would have the same effect as setScale(Vector3(4,4,4)) if the existing scale was 1.

  Note that like rotations, scalings are oriented around the node's origin.

virtual void Ogre::SceneNode::setAutoTracking | ( | bool | enabled,
|  | SceneNode * | target = `0`,
|  | const Vector3 & | localDirectionVector = `Vector3::NEGATIVE_UNIT_Z`,
|  | const Vector3 & | offset = `Vector3::ZERO`
| ) | `[virtual]`

Enables / disables automatic tracking of another SceneNode.

Remarks:
  If you enable auto-tracking, this SceneNode will automatically rotate to point it's -Z at the target SceneNode every frame, no matter how it or the other SceneNode move. Note that by default the -Z points at the origin of the target SceneNode, if you want to tweak this, provide a vector in the 'offset' parameter and the target point will be adjusted.

Parameters:

  | enabled | If true, tracking will be enabled and the next parameter cannot be null. If false tracking will be disabled and the current orientation will be maintained.
  | target | Pointer to the SceneNode to track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  | localDirectionVector | The local vector considered to be the usual 'direction' of the node; normally the local -Z but can be another direction.
  | offset | If supplied, this is the target point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks:
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters:

  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.

Definition at line 204 of file OgreRenderable.h.

virtual void Ogre::SceneNode::setDirection | ( | const Vector3 & | vec,
|  | TransformSpace | relativeTo = `TS_LOCAL`,
|  | const Vector3 & | localDirectionVector = `Vector3::NEGATIVE_UNIT_Z`
| ) | `[virtual]`

Sets the node's direction vector ie it's local -z.

Remarks:
  Note that the 'up' vector for the orientation will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same). If you need more control, use setOrientation.

Parameters:

  | vec | The direction vector
  | relativeTo | The space in which this direction vector is expressed
  | localDirectionVector | The vector which normally describes the natural direction of the node, usually -Z

virtual void Ogre::SceneNode::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_LOCAL`,
|  | const Vector3 & | localDirectionVector = `Vector3::NEGATIVE_UNIT_Z`
| ) | `[virtual]`

Sets the node's direction vector ie it's local -z.

Remarks:
  Note that the 'up' vector for the orientation will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same). If you need more control, use setOrientation.

Parameters:

  | x,y,z | The components of the direction vector
  | relativeTo | The space in which this direction vector is expressed
  | localDirectionVector | The vector which normally describes the natural direction of the node, usually -Z

virtual void Ogre::SceneNode::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = `Vector3::UNIT_Y`
| ) | `[virtual]`

Tells the node whether to yaw around it's own local Y axis or a fixed axis of choice.

Remarks:
  This method allows you to change the yaw behaviour of the node - by default, it yaws around it's own local Y axis when told to yaw with TS_LOCAL, this makes it yaw around a fixed axis. You only really need this when you're using auto tracking (see setAutoTracking, because when you're manually rotating a node you can specify the TransformSpace in which you wish to work anyway.

Parameters:

  | useFixed | If true, the axis passed in the second parameter will always be the yaw axis no matter what the node orientation. If false, the node returns to it's default behaviour.
  | fixedAxis | The axis to use if the first parameter is true.

virtual void Ogre::Node::setInheritOrientation | ( | bool | inherit | ) | `[virtual, inherited]`

Tells the node whether it should inherit orientation from it's parent node.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

Parameters:

  | inherit | If true, this node's orientation will be affected by its parent's orientation. If false, it will not be affected.

virtual void Ogre::Node::setInheritScale | ( | bool | inherit | ) | `[virtual, inherited]`

Tells the node whether it should inherit scaling factors from it's parent node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

Parameters:

  | inherit | If true, this node's scale will be affected by its parent's scale. If false, it will not be affected.

virtual void Ogre::Node::setInitialState | ( | void |  | ) | `[virtual, inherited]`

Sets the current transform of this node to be the 'initial state' ie that position / orientation / scale to be used as a basis for delta values used in keyframe animation.

Remarks:
  You never need to call this method unless you plan to animate this node. If you do plan to animate it, call this method once you've loaded the node with it's base state, ie the state on which all keyframes are based.

  If you never call this method, the initial state is the identity transform, ie do nothing.

virtual void Ogre::SceneNode::setInSceneGraph | ( | bool | inGraph | ) | `[protected, virtual]`

| Internal method for setting whether the node is in the scene graph.

virtual void Ogre::Node::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this Node.

Remarks:
  Note for size and performance reasons only one listener per node is allowed.

Definition at line 638 of file OgreNode.h.

virtual void Ogre::Node::setOrientation | ( | Real | w,
|  | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Sets the orientation of this node via quaternion parameters.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

virtual void Ogre::Node::setOrientation | ( | const Quaternion & | q | ) | `[virtual, inherited]`

Sets the orientation of this node via a quaternion.

Remarks:
  Orientatings, unlike other transforms, are not always inherited by child nodes. Whether or not orientatings affect the orientation of the child nodes depends on the setInheritOrientation option of the child. In some cases you want a orientating of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative orientation based on the parent's orientation), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own orientation). The default is to inherit as with other transforms.

  Note that rotations are oriented around the node's origin.

void Ogre::SceneNode::setParent | ( | Node * | parent | ) | `[protected, virtual]`

| See Node. Reimplemented from Ogre::Node.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters:

  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.

Definition at line 269 of file OgreRenderable.h.

virtual void Ogre::Node::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

| Sets the position of the node relative to it's parent.

virtual void Ogre::Node::setPosition | ( | const Vector3 & | pos | ) | `[virtual, inherited]`

| Sets the position of the node relative to it's parent.

virtual void Ogre::Node::setScale | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) | `[virtual, inherited]`

Sets the scaling factor applied to this node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the node's origin.

virtual void Ogre::Node::setScale | ( | const Vector3 & | scale | ) | `[virtual, inherited]`

Sets the scaling factor applied to this node.

Remarks:
  Scaling factors, unlike other transforms, are not always inherited by child nodes. Whether or not scalings affect the size of the child nodes depends on the setInheritScale option of the child. In some cases you want a scaling factor of a parent node to apply to a child node (e.g. where the child node is a part of the same object, so you want it to be the same relative size based on the parent's size), but not in other cases (e.g. where the child node is just for positioning another object, you want it to maintain it's own size). The default is to inherit as with other transforms.

  Note that like rotations, scalings are oriented around the node's origin.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

Sets whether or not to use an 'identity' projection.

Remarks:
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityProjection

Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

Sets whether or not to use an 'identity' view.

Remarks:
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also:
  Renderable::getUseIdentityView

Definition at line 147 of file OgreRenderable.h.

virtual void Ogre::SceneNode::setVisible | ( | bool | visible,
|  | bool | cascade = `true`
| ) | `[virtual]`

Makes all objects attached to this node become visible / invisble.

Remarks:
  This is a shortcut to calling setVisible() on the objects attached to this node, and optionally to all objects attached to child nodes.

Parameters:

  | visible | Whether the objects are to be made visible or invisible
  | cascade | If true, this setting cascades into child nodes too.

virtual void Ogre::SceneNode::showBoundingBox | ( | bool | bShow | ) | `[virtual]`

Allows the showing of the node's bounding box.

Remarks:
  Use this to show or hide the bounding box of the node.

virtual void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along arbitrary axes.

Remarks:
  This method translates the node by a vector which is relative to a custom set of axes.

Parameters:

  axes

  A 3x3 Matrix containg 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as

                      1 0 0
                      0 1 0
                      0 0 1

  i.e. the identity matrix.

  | x,y,z | Translation components relative to the axes above.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | const Matrix3 & | axes,
|  | const Vector3 & | move,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along arbitrary axes.

Remarks:
  This method translates the node by a vector which is relative to a custom set of axes.

Parameters:

  axes

  A 3x3 Matrix containg 3 column vectors each representing the axes X, Y and Z respectively. In this format the standard cartesian axes would be expressed as:

                      1 0 0
                      0 1 0
                      0 0 1

  i.e. the identity matrix.

  | move | Vector relative to the axes above.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along the cartesian axes.

  This method moves the node by the supplied vector along the world cartesian axes, i.e. along world x,y,z

Parameters:

  | x |
  | y |
  | z | Real x, y and z values representing the translation.
  | relativeTo | The space which this transform is relative to.

virtual void Ogre::Node::translate | ( | const Vector3 & | d,
|  | TransformSpace | relativeTo = `TS_PARENT`
| ) | `[virtual, inherited]`

Moves the node along the cartesian axes.

  This method moves the node by the supplied vector along the world cartesian axes, i.e. along world x,y,z

Parameters:

  | d | Vector with x,y,z values representing the translation.
  | relativeTo | The space which this transform is relative to.

void Ogre::SceneNode::updateFromParentImpl | ( | void |  | ) | const`[protected, virtual]`

Remarks:
  Splitting the implementation of the update away from the update call itself allows the detail to be overridden without disrupting the general sequence of updateFromParent (e.g. raising events)

.

Reimplemented from Ogre::Node.

virtual void Ogre::SceneNode::yaw | ( | const Radian & | angle,
|  | TransformSpace | relativeTo = `TS_LOCAL`
| ) | `[virtual]`

| Rotate the node around the Y-axis. Reimplemented from Ogre::Node.

## Member Data Documentation

Vector3 Ogre::SceneNode::mAutoTrackLocalDirection`[protected]`

| Local 'normal' direction vector. Definition at line 100 of file OgreSceneNode.h.

Vector3 Ogre::SceneNode::mAutoTrackOffset`[protected]`

| Tracking offset for fine tuning. Definition at line 98 of file OgreSceneNode.h.

SceneNode* Ogre::SceneNode::mAutoTrackTarget`[protected]`

| Auto tracking target. Definition at line 96 of file OgreSceneNode.h.

Matrix4 Ogre::Node::mCachedTransform`[mutable, protected, inherited]`

| Cached derived transform as a 4x4 matrix. Definition at line 198 of file OgreNode.h.

bool Ogre::Node::mCachedTransformOutOfDate`[mutable, protected, inherited]`

| Definition at line 199 of file OgreNode.h.

ChildNodeMap Ogre::Node::mChildren`[protected, inherited]`

| Collection of pointers to direct children; hashmap for efficiency. Definition at line 99 of file OgreNode.h.

ChildUpdateSet Ogre::Node::mChildrenToUpdate`[mutable, protected, inherited]`

| List of children which need updating, used if self is not out of date but children are. Definition at line 103 of file OgreNode.h.

SceneManager* Ogre::SceneNode::mCreator`[protected]`

| SceneManager which created this node. Definition at line 68 of file OgreSceneNode.h.

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

Quaternion Ogre::Node::mDerivedOrientation`[mutable, protected, inherited]`

Cached combined orientation.

  This member is the orientation derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 147 of file OgreNode.h.

Vector3 Ogre::Node::mDerivedPosition`[mutable, protected, inherited]`

Cached combined position.

  This member is the position derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 156 of file OgreNode.h.

Vector3 Ogre::Node::mDerivedScale`[mutable, protected, inherited]`

Cached combined scale.

  This member is the position derived by combining the local transformations and those of it's parents. This is updated when _updateFromParent is called by the SceneManager or the nodes parent.

Definition at line 165 of file OgreNode.h.

bool Ogre::Node::mInheritOrientation`[protected, inherited]`

| Stores whether this node inherits orientation from it's parent. Definition at line 129 of file OgreNode.h.

bool Ogre::Node::mInheritScale`[protected, inherited]`

| Stores whether this node inherits scale from it's parent. Definition at line 132 of file OgreNode.h.

Quaternion Ogre::Node::mInitialOrientation`[protected, inherited]`

| The orientation to use as a base for keyframe animation. Definition at line 193 of file OgreNode.h.

Vector3 Ogre::Node::mInitialPosition`[protected, inherited]`

| The position to use as a base for keyframe animation. Definition at line 191 of file OgreNode.h.

Vector3 Ogre::Node::mInitialScale`[protected, inherited]`

| The scale to use as a base for keyframe animation. Definition at line 195 of file OgreNode.h.

bool Ogre::SceneNode::mIsInSceneGraph`[protected]`

| Is this node a current part of the scene graph? Definition at line 102 of file OgreSceneNode.h.

Listener* Ogre::Node::mListener`[protected, inherited]`

| Node listener - only one allowed (no list) for size & performance reasons. Definition at line 202 of file OgreNode.h.

String Ogre::Node::mName`[protected, inherited]`

| Friendly name of this node, can be automatically generated if you don't care. Definition at line 114 of file OgreNode.h.

bool Ogre::Node::mNeedChildUpdate`[mutable, protected, inherited]`

| Flag indicating that all children need to be updated. Definition at line 107 of file OgreNode.h.

bool Ogre::Node::mNeedParentUpdate`[mutable, protected, inherited]`

| Flag to indicate own transform from parent is out of date. Definition at line 105 of file OgreNode.h.

ObjectMap Ogre::SceneNode::mObjectsByName`[protected]`

| Definition at line 60 of file OgreSceneNode.h.

Quaternion Ogre::Node::mOrientation`[protected, inherited]`

| Stores the orientation of the node relative to it's parent. Definition at line 120 of file OgreNode.h.

Node* Ogre::Node::mParent`[protected, inherited]`

| Pointer to parent node. Definition at line 97 of file OgreNode.h.

bool Ogre::Node::mParentNotified`[mutable, protected, inherited]`

| Flag indicating that parent has been notified about update request. Definition at line 109 of file OgreNode.h.

MaterialPtr Ogre::Node::mpMaterial`[mutable, protected, inherited]`

| Material pointer should this node be rendered. Definition at line 135 of file OgreNode.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

Vector3 Ogre::Node::mPosition`[protected, inherited]`

| Stores the position/translation of the node relative to its parent. Definition at line 123 of file OgreNode.h.

bool Ogre::Node::mQueuedForUpdate`[mutable, protected, inherited]`

| Flag indicating that the node has been queued for update. Definition at line 111 of file OgreNode.h.

Vector3 Ogre::Node::mScale`[protected, inherited]`

| Stores the scaling factor applied to this node. Definition at line 126 of file OgreNode.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

bool Ogre::SceneNode::mShowBoundingBox`[protected]`

| Flag that determines if the bounding box of the node should be displayed. Definition at line 65 of file OgreSceneNode.h.

unsigned long Ogre::Node::msNextGeneratedNameExt`[static, protected, inherited]`

| Incremented count for next name extension. Definition at line 117 of file OgreNode.h.

QueuedUpdates Ogre::Node::msQueuedUpdates`[static, protected, inherited]`

| Definition at line 205 of file OgreNode.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

WireBoundingBox* Ogre::SceneNode::mWireBoundingBox`[protected]`

| Pointer to a Wire Bounding Box for this Node. Definition at line 63 of file OgreSceneNode.h.

AxisAlignedBox Ogre::SceneNode::mWorldAABB`[protected]`

| World-Axis aligned bounding box, updated only through _update. Definition at line 71 of file OgreSceneNode.h.

bool Ogre::SceneNode::mYawFixed`[protected]`

| Whether to yaw around a fixed axis. Definition at line 91 of file OgreSceneNode.h.

Vector3 Ogre::SceneNode::mYawFixedAxis`[protected]`

| Fixed axis to yaw around. Definition at line 93 of file OgreSceneNode.h.

The documentation for this class was generated from the following file:

- OgreSceneNode.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:43 2008